/*
******************************************************************************
File:     main.c
Info:     Generated by Atollic TrueSTUDIO(R) 9.3.0   2024-06-01

The MIT License (MIT)
Copyright (c) 2019 STMicroelectronics

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all
copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
SOFTWARE.

******************************************************************************
*/

/* Includes */
#include "stm32f4xx.h"
#include "stm32f4xx_rcc.h"
#include "stm32f4xx_gpio.h"

/* Private macro */
/* Private variables */
/* Private function prototypes */
/* Private functions */

///* task 1, 2, 3
#define MASK(x) (1U << (x))
//*/

/**
**===========================================================================
**
**  Abstract: main program
**
**===========================================================================
*/
int main(void)
{
	volatile int i = 0;

/* task 1
 	volatile unsigned int* GPIO_D = (unsigned int*)0x40020C00;
	volatile unsigned int* GPIO_D_MODER_reg = (unsigned int*)0x40020C00;
	volatile unsigned int* GPIO_D_ODR_reg = (unsigned int*)(0x40020C14);
	volatile unsigned int* RCC_AHB1ENR_reg = (unsigned int*)(0x40023830);

	*RCC_AHB1ENR_reg |= MASK(3); //uključivanje takta za port D
	*GPIO_D_MODER_reg |= MASK(30); //PD15 se koristi kao izlazni pin
	*GPIO_D_ODR_reg |= MASK(15); //postavljanje PD15 u logičku “1”
*/

/* task 2
	RCC->AHB1ENR |= MASK(3); //uključivanje takta za port D
	GPIOD->MODER |= MASK(30); //PD15 se koristi kao izlazni pin
	GPIOD->ODR |= MASK(15); //postavljanje PD15 u logičku “1”
*/

/* task 3
	int toggle = 1;

	RCC->AHB1ENR |= MASK(0); // ukljucivanje takta za port GPIO A
	GPIOA->MODER &= ~MASK(0); // PA0 se koristi kao ulazni pin

	RCC->AHB1ENR |= MASK(3);
	GPIOD->MODER |= MASK(30);
*/

/* task 4
	int toggle = 1;

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE); //uključivanje takta za port D
	GPIO_InitTypeDef GPIO_InitStructure; //inicijalizacijska struktura
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15; //pin 15 se konfigurira
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT; //koristi se kao izlazni pin
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP; //push-pull konfiguracija
	GPIO_Init(GPIOD, &GPIO_InitStructure); //zapisivanje u konfiguracijske registre portaD

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE); //ukljucivanje takta za GPIO port A
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN;
	GPIO_Init(GPIOA, &GPIO_InitStructure);

	//GPIO_SetBits(GPIOD,GPIO_Pin_15); //postavljanje PD15 u logičku “1”
*/

///* task 5
	//konfiguriranje on-board LED-ica
	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOD, ENABLE);
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_15 | GPIO_Pin_14 | GPIO_Pin_13 | GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;
	GPIO_Init(GPIOD, &GPIO_InitStructure);

	uint16_t result = 0;

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOB, ENABLE); //uključivanje takta za port B
	// pin PB1 se koristi u analognom načinu rada
	GPIO_InitTypeDef GPIO_InitStructADC; // inicijalizacijska struktura za ADC
	GPIO_InitStructADC.GPIO_Mode = GPIO_Mode_AN; // konfigurira se kao analogni ulaz
	GPIO_InitStructADC.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructADC.GPIO_PuPd = GPIO_PuPd_NOPULL;
	GPIO_Init(GPIOB, &GPIO_InitStructADC);

	// omogućavanje takta za prvi A/D pretvornik
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);
	// inicijalizacijska struktura za prvi A/D pretvornik
	ADC_InitTypeDef ADC1_InitStruct;
	// rezolucija A/D pretvorbe
	ADC1_InitStruct.ADC_Resolution = ADC_Resolution_12b;
	// pretvorba jednog kanala
	ADC1_InitStruct.ADC_ScanConvMode = DISABLE;
	// koristi se pojedinačni način rada
	ADC1_InitStruct.ADC_ContinuousConvMode = DISABLE;
	// ne koristi se vanjski okidač za pokretanje pretvorbe
	ADC1_InitStruct.ADC_ExternalTrigConv = DISABLE;
	ADC1_InitStruct.ADC_ExternalTrigConvEdge = ADC_ExternalTrigConvEdge_None;
	// desno poravnanje rezultata u ADC_DR registru
	ADC1_InitStruct.ADC_DataAlign = ADC_DataAlign_Right;
	// broj pretvorbi
	ADC1_InitStruct.ADC_NbrOfConversion = 1;
	// zapisivanje postavki u konfiguracijske registre A/D pretvornika
	ADC_Init(ADC1, &ADC1_InitStruct);
	// pin PB1 je spojen na 9 kanal prvog A/D pretvornika
	ADC_RegularChannelConfig(ADC1, ADC_Channel_9, 1, ADC_SampleTime_84Cycles);
	// omogući rad prvog A/D pretvornika
	ADC_Cmd(ADC1, ENABLE);

	// pokreni A/D pretvorbu
	//ADC_SoftwareStartConv(ADC1);
	// "čekaj" dok se ne završi pretvorba na prvom A/D pretvorniku
	//while (!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));
	//dohvati rezultat pretvorbe s prvog A/D pretvornika
	//result = ADC_GetConversionValue(ADC1);
//*/

	while (1)
	{
	/* task 1
		*GPIO_D_ODR_reg |= MASK(15);
		for(i = 0; i < 5000000; i++);
		*GPIO_D_ODR_reg &= ~MASK(15);
		for(i = 0; i < 5000000; i++);
	*/

	/* task 2
		GPIOD->ODR |= MASK(15);
		for(i = 0; i < 5000000; i++);
		GPIOD->ODR &= ~MASK(15);
		for(i = 0; i < 5000000; i++);
	*/

	/* task 3
		if(GPIOA->IDR & MASK(0))
		{
			for(i = 0; i < 100000; i++); // debounce delay

			if(GPIOA->IDR & MASK(0)) // provjera ako je tipkalo i dalje pritisnuto
			{
				toggle = !toggle;

				while(GPIOA->IDR & MASK(0)); // cekanje dok se tipkalo ne otpusti
			}
		}

		if(toggle)
		{
			GPIOD->ODR |= MASK(15);
			for(i = 0; i < 3500000; i++);
			GPIOD->ODR &= ~MASK(15);
			for(i = 0; i < 3500000; i++);
		}
		else
		{
			GPIOD->ODR &= ~MASK(15);
		}
	*/

	/* task 4
		if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0))
		{
			for(i = 0; i < 100000; i++); // debounce delay

			if(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)) // provjera ako je tipkalo i dalje pritisnuto
			{
				toggle = !toggle;

				while(GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_0)); // cekanje dok se tipkalo ne otpusti
			}
		}

		if(toggle)
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_15);
			for(i = 0; i < 3500000; i++);
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
			for(i = 0; i < 3500000; i++);
		}
		else
		{
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
		}
	*/

	///* task 5
		ADC_SoftwareStartConv(ADC1);

		while(!ADC_GetFlagStatus(ADC1, ADC_FLAG_EOC));

		result = ADC_GetConversionValue(ADC1);

		// 12 bit = [0, 4095]

		// result < 10%
		if(result < 410)
		{
			GPIO_ResetBits(GPIOD, GPIO_Pin_12);
			GPIO_ResetBits(GPIOD, GPIO_Pin_13);
			GPIO_ResetBits(GPIOD, GPIO_Pin_14);
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
		}
		// result >= 10% && < 25%
		else if(result >= 410 && result < 1024)
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_12);
			GPIO_ResetBits(GPIOD, GPIO_Pin_13);
			GPIO_ResetBits(GPIOD, GPIO_Pin_14);
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
		}
		// result >= 25% && < 50%
		else if(result >= 1024 && result < 2048)
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_12);
			GPIO_SetBits(GPIOD, GPIO_Pin_13);
			GPIO_ResetBits(GPIOD, GPIO_Pin_14);
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
		}
		// result >= 50% && < 75%
		else if(result >= 2048 && result < 3072)
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_12);
			GPIO_SetBits(GPIOD, GPIO_Pin_13);
			GPIO_SetBits(GPIOD, GPIO_Pin_14);
			GPIO_ResetBits(GPIOD, GPIO_Pin_15);
		}
		// result >= 75%
		else
		{
			GPIO_SetBits(GPIOD, GPIO_Pin_12);
			GPIO_SetBits(GPIOD, GPIO_Pin_13);
			GPIO_SetBits(GPIOD, GPIO_Pin_14);
			GPIO_SetBits(GPIOD, GPIO_Pin_15);
		}
	//*/
	}
}
